sc::OneBodyInt Class Referenceabstract

OneBodyInt is an abstract base class for objects that compute integrals between two basis functions. More...

`#include <obint.h>`

Inheritance diagram for sc::OneBodyInt:
[legend]
Collaboration diagram for sc::OneBodyInt:
[legend]

## Public Member Functions

int | nbasis () const
| Returns the number of basis functions on center one.
int | nbasis1 () const
| Returns the number of basis functions on the center one.
int | nbasis2 () const
| Returns the number of basis functions on the center two.
int | nshell () const
| Return the number of shells on center one.
int | nshell1 () const
| Return the number of shells on the center one.
int | nshell2 () const
| Return the number of shells on the center two.
Ref< GaussianBasisSet > | basis ()
| Return the basis set on center one.
Ref< GaussianBasisSet > | basis1 ()
| Return the basis set on the center one.
Ref< GaussianBasisSet > | basis2 ()
| Return the basis set on the center two.
const double * | buffer () const
| Returns the buffer where the integrals are placed.
virtual void | compute_shell (int, int)=0
| Computes the integrals between basis functions in the given shell pair. More...
virtual void | reinitialize ()
| This is called for one body integrals that take data to let them know that the data they reference has changed. More...
virtual bool | cloneable ()
| Return true if the clone member can be called. More...
virtual Ref< OneBodyInt > | clone ()
| Returns a clone of this. More...
Integral * | integral () const
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Member Functions

| OneBodyInt (Integral *integral, const Ref< GaussianBasisSet > &b1, const Ref< GaussianBasisSet > &b2=0)
Protected Member Functions inherited from sc::RefCount
| RefCount (const RefCount &)
RefCount & | operator= (const RefCount &)

## Protected Attributes

Integral * | integral_
Ref< GaussianBasisSet > | bs1_
Ref< GaussianBasisSet > | bs2_
double * | buffer_

## Detailed Description

OneBodyInt is an abstract base class for objects that compute integrals between two basis functions.

## Member Function Documentation

virtual Ref<OneBodyInt> sc::OneBodyInt::clone | ( |  | ) |

virtual

Returns a clone of this.

The default implementation throws an exception.

Reimplemented in sc::OneBodyIntCCA, sc::OneBodyIntCints, and sc::OneBodyIntV3.

virtual bool sc::OneBodyInt::cloneable | ( |  | ) |

virtual

Return true if the clone member can be called.

The default implementation returns false.

Reimplemented in sc::OneBodyIntCCA, sc::OneBodyIntCints, and sc::OneBodyIntV3.

virtual void sc::OneBodyInt::compute_shell | ( | int | ,
|  | int |
| ) |  |

pure virtual

Computes the integrals between basis functions in the given shell pair.

Implemented in sc::DipoleIntV3, sc::EfieldDotVectorIntV3, sc::PointChargeIntV3, sc::OneBodyIntCCA, sc::OneBodyIntCints, and sc::OneBodyIntV3.

virtual void sc::OneBodyInt::reinitialize | ( |  | ) |

virtual

This is called for one body integrals that take data to let them know that the data they reference has changed.

The documentation for this class was generated from the following file:

- obint.h